%global pkg mellanox
%global kernel 5.10.134-18.an8
%define pkg_version 5.8
%define anolis_release 1
%define debug_package %{nil} 
%undefine _hardened_build

Name:        kmod-%{pkg}
Version:     %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:     %{pkg_version}~%{anolis_release}%{?dist}
Summary:     Mellanox NIC drivers
License:     GPL-v2
Source0:     kmod-%{pkg}-%{pkg_version}.tar.gz

Requires: kmod
Requires: dracut
BuildRequires: kernel-devel  = %{kernel}
BuildRequires: gcc kmod elfutils-libelf-devel automake

Provides: kmod-%{pkg}-%{kernel}.%{_arch} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kernel}.%{_arch} < %{version}-%{release}

%description
Mellanox(R) NIC adapters 25G

%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build
#cd mlnx-ofa_kernel-%{pkgversion}/
cd src
./configure --kernel-version=%{kernel}.%{_arch} --kernel-sources=/usr/src/kernels/%{kernel}.%{_arch} \
    --build-dummy-mods --with-core-mod --with-user_mad-mod --with-user_access-mod \
    --with-addr_trans-mod --with-mlx5-mod --with-mlxfw-mod --with-ipoib-mod --without-xdp -j32
make -j32

%install
cd src
make install INSTALL_MOD_PATH=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/etc/infiniband/
cp ofed_scripts/vf-net-link-name.sh $RPM_BUILD_ROOT/etc/infiniband/
mkdir -p $RPM_BUILD_ROOT/lib/udev/rules.d
cp ofed_scripts/82-net-setup-link.rules $RPM_BUILD_ROOT/lib/udev/rules.d/

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

# Generate depmod.conf
%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    dracut -f --kver "$kversion" > /dev/null 2>&1
done

#find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' | weak-modules --no-initramfs --add-modules

for module in mlxfw.ko mlx_compat.ko; do
    find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name ${module} | weak-modules --no-initramfs --add-modules > /dev/null 2>&1
done

for module in mlxdevm.ko ib_core.ko xprtrdma.ko rpcrdma.ko svcrdma.ko smc_diag.ko smc.ko mlxsw_spectrum.ko nvme-rdma.ko nvmet-rdma.ko opa_vnic.ko \
ib_srpt.ko ib_iser.ko ib_isert.ko ib_srp.ko usnic_verbs.ko qedr.ko ocrdma.ko hfi1.ko mlx4_ib.ko bnxt_re.ko ib_mthca.ko vmw_pvrdma.ko iw_cxgb4.ko \
efa.ko i40iw.ko ib_ucm.ko rdmavt.ko rdma_rxe.ko siw.ko; do
    find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name ${module} | weak-modules --no-initramfs --add-modules > /dev/null 2>&1
done

for module in mlx5_core.ko ib_cm.ko iw_cm.ko ib_uverbs.ko ib_umad.ko; do
    find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name ${module} | weak-modules --no-initramfs --add-modules > /dev/null 2>&1
done

for module in ib_ipoib.ko rdma_cm.ko mlx5_ib.ko; do
    find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name ${module} | weak-modules --no-initramfs --add-modules > /dev/null 2>&1
done 

for module in rpcrdma.ko ib_isert.ko rdma_ucm.ko; do
    find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name ${module} | weak-modules  --no-initramfs --add-modules > /dev/null 2>&1
done

%preun
for module in `find /lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/ -name '*.ko' -o -name '*.ko.gz' | sort`
do
	echo "$module" >> /var/run/rpm-%{pkg}-modules.list
done

%postun
/sbin/depmod -a > /dev/null 2>&1

for kernel in /lib/modules/*; do
    kversion=$(basename $kernel)
    dracut -f --kver "$kversion" > /dev/null 2>&1
done

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list

%files
/lib/modules/%{kernel}.%{_arch}/extra/mlnx-ofa_kernel/*
%exclude /lib/modules/%{kernel}.%{_arch}/modules.alias
%exclude /lib/modules/%{kernel}.%{_arch}/modules.symbols
%exclude /lib/modules/%{kernel}.%{_arch}/modules.softdep
%exclude /lib/modules/%{kernel}.%{_arch}/modules.devname
%exclude /lib/modules/%{kernel}.%{_arch}/modules.dep
%exclude /lib/modules/%{kernel}.%{_arch}/modules.symbols.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.builtin.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.dep.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.alias.bin
%exclude /lib/modules/%{kernel}.%{_arch}/modules.builtin.alias.bin
/etc/infiniband/openib.conf
/etc/init.d/openibd
/etc/modprobe.d/mlnx.conf
/etc/modprobe.d/ib_ipoib.conf
/usr/sbin/setup_mr_cache.sh
/etc/infiniband/mlx5.conf
/etc/infiniband/vf-net-link-name.sh
/usr/sbin/odp_stat.sh
/etc/modprobe.d/mlnx-bf.conf
/usr/sbin/ibdev2netdev
/lib/udev/auxdev-sf-netdev-rename
/lib/udev/rules.d/82-net-setup-link.rules
/lib/udev/rules.d/83-mlnx-sf-name.rules
/lib/udev/rules.d/90-ib.rules
/lib/udev/sf-rep-netdev-rename
/usr/share/mlnx_ofed/mlnx_bf_assign_ct_cores.sh
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

%changelog
* Thu May 26 2022 lq.hj <lq.h@alibaba-inc.com> - 5.8
- mellanox driver 5.8 build for 5.10.134-15.1.an8
